/*
 *  fatal -- issue a diagnostic message and terminate
 */

#include <stdio.h>
#include <stdlib.h>

void
fatal(mesg, errlevel)
char *mesg;     /* message text */
int errlevel;   /* errorlevel (exit code) */
{
    char *p;

	/* display error message */
	fprintf(stderr,"\r\n* * * Error %d, ",errlevel);
	for (p = mesg; *p; p++)
	  switch (*p)
	    { case '~':
		fprintf(stderr,"Invalid ");
		break;
	      case '#':
		fprintf(stderr,"Number");
		break;
	      case '@':
		fprintf(stderr,"Location");
		break;
	      case '<':
		fprintf(stderr,"Format");
		break;
	      case '&':
		fprintf(stderr,"for this");
		break;
	      case '\\':	/* Quote next character */
		putc(*++p,stderr);
		break;
	      default:
		putc(*p,stderr);
		break;
	    };

	fprintf(stderr," * * *\n\n");

	/* Error Level 9 is Wrong Hardware -- exit immediately */
	if (errlevel != 9)
	{ exit_keys();
	  setcur(22,0);
	}

	/* return to DOS with the specified errorlevel */
	exit(errlevel);
}

static char bars[]="\n----------";

/* ---------------------------fatal_line------------------------------ */
fatal_line(the_bad_line,message,err_no)
char *the_bad_line;
char *message;
int err_no;
{char *lastchar;

	/* Don't print double newlines... */
    lastchar = the_bad_line+strlen(the_bad_line)-1;
    if (*lastchar == '\n') *lastchar = '\0';
    printf("%s\n%s%s",bars,the_bad_line,bars);
    fatal (message,err_no);
}

/* ---------------------------go_fatal------------------------------ */
go_fatal(fname, message,err_no)
char *fname;
char *message;   int err_no;
{   char t[80];
    sprintf(t,"File %s: %s",fname,message);
    fatal (t,err_no);
}
