/* initform - Part of Form Filler program

Initialization for the program

*/
#include "globals.h"
#include <stdlib.h>

/* Color attributes */
extern int	cur_attr;
extern int	nor_attr;
extern int	inv_attr;

extern void	window_size(int top_mgn,int bottom_mgn);

static char InvSwitch[]="~Switch";
static char InvArg[]="~Argument";
static char help [] =
"Valid Switches are:\r\n\
\t/D\t\tDebug Mode\r\n\
\t/P printfile\tSpecifies print file\r\n\
\t/X inputfile\tSpecifies input data file";

/*
	OpenFile

	Attempts to open a file -- looks in the current directory
	first; then looks through all the directories in the Path.
*/
static FILE *OpenFile(char *wholename, char *fname)
{
    _searchenv(fname,Path,wholename);
    if (*wholename)	/* If file found */
	return(fopen(wholename,ReadBinary));
    else
	return(NULL);
}

int initform(argc,argv)
int          argc;
char            *argv[];

{
int ret=0;
int  arg;
FILE *helpfile, *env_file;
char env_name[80], temp[80];
static char Hex_Num[]="%x";

    temp1[0]='\0';
    if (_osmajor < 2)
        fatal ("DOS 2 Required!", 1);
    /* Look for help file in default directory first */
    helpfile=OpenFile(helpname,HelpFile);
    if (helpfile != NULL)
	fclose (helpfile);
    else
	strcpy(helpname,HelpFile);

    cur_attr = nor_attr = 0x07;
    inv_attr = 0x70;
    window_size(1,0);

    /* Look for setup file in default directory first */
    env_file = OpenFile(env_name,EnvFile);
    if (env_file != NULL)
    {	if (fgets(temp,80,env_file) != NULL)
        {   sscanf(temp,Hex_Num,&nor_attr);
            cur_attr = nor_attr;
        }
        if (fgets(temp,80,env_file) != NULL)
            sscanf(temp,Hex_Num,&inv_attr);
        fclose (env_file);
    }

    debug = 0;
    *temp1 = *temp2 = *temp3 = '\0';    /* clear the filenames */
    for (arg = 1; arg < argc; ++arg)
    {   strupr(argv[arg]);
        if (argv[arg][0] == '-' || argv[arg][0] == '/')
        {   /* Process switch */
            switch (argv[arg][1])
            {   case 'D':
                    debug = 1;
                    break;
                case 'X':               /* External input */
                    ext_input = 1;
                    if (*temp3 == '\0' && ++arg < argc)
		      { strcpy(temp3,argv[arg]); /* Input file name */
			strupr(temp3);
		      }
                    else
                        { printf(help); fatal(InvArg,10); }
                    break;
                case 'P':               /* Print file name */
                    if (*temp2 == '\0' && ++arg < argc)
		      { strcpy(temp2,argv[arg]); /* Print file name */
			strupr(temp2);
		      }
                    else
                        { printf(help); fatal(InvArg,10); }
                    break;
                default:
		    printf(help);
                    fatal_line(argv[arg],InvSwitch,10);
            }
        }
        else
            if (*temp1 == '\0')
	      { strcpy(temp1,argv[arg]); /* Form file name */
		strupr(temp1);
		if (strstr(temp1,FormDefn) == NULL && strstr(temp1,".") == NULL) 
		    strcat(temp1,FormDefn);
	      }
            else
		fatal_line(argv[arg],InvArg,10);
    }
    get_mode=0;

	first_field = cur_field = last_field = first_print_field =
	first_data_field = NULL;

    if (ext_input)
        restform();
    else
    {   if (strlen(temp1) > 0) {newform(); ret = F2;}
        if (strlen(temp2) > 0) newout();
    }
    wchar('\2');
    get_mode=1;
    return(ret);
}
