/*--------------------------- save_video ---------------------
    Saves video bounded by t_row1,l_col and b_row r_col
*/
void save_video(t_row,l_col,b_row,r_col,ptr)
int t_row,l_col,b_row,r_col;
unsigned int *ptr;
{   int i,j,p;
    p = getpage();
    for (i=t_row; i<=b_row; i++)
        for (j=l_col; j<=r_col; j++)
        {   setcur(i,j);
            Regs.h.bh=p;
            Regs.h.ah=READ_CHR;
            *ptr++ = int86(VIDEO_INT, &Regs, &Regs);
            wchar(' '); /* clear this location */
        }
    return;
}
/*--------------------------- restore_video ---------------------
    Restores video bounded by t_row1,l_col and b_row r_col
*/
void restore_video(t_row,l_col,b_row,r_col,ptr)
int t_row,l_col,b_row,r_col;
unsigned char *ptr;
{   int i,j,p;
    p = getpage();
    for (i=t_row; i<=b_row; i++)
        for (j=l_col; j<=r_col; j++)
        {   setcur(i,j);
            Regs.h.ah=WRITE_CHR;
            Regs.h.bh=p;        /* page */
            Regs.x.cx=1;        /* one character */
            Regs.h.al=*ptr++;   /* character */
            Regs.h.bl=*ptr++;   /* attribute */
            int86(VIDEO_INT, &Regs, &Regs);
        }
    return;
}
/*--------------------------- draw_box ---------------------------
    Draws a box around area bounded by t_row1,l_col and b_row r_col
*/
void draw_box(t_row,l_col,b_row,r_col)
int t_row,l_col,b_row,r_col;
{   int i,j,p;
    p = getpage();
    for (i=l_col+1; i<r_col; i++)
    {   setcur(t_row,i);
        wchar(196);
        setcur(b_row,i);
        wchar(196);
    }
    for (i=t_row+1; i<b_row; i++)
    {   setcur(i,l_col);
        wchar(179);
        setcur(i,r_col);
        wchar(179);
    }
    setcur(t_row,l_col);
    wchar(218);
    setcur(t_row,r_col);
    wchar(191);
    setcur(b_row,l_col);
    wchar(192);
    setcur(b_row,r_col);
    wchar(217);
    return;
}
/*--------------------------- display_menu ---------------------
    Displays a menu at row,col
*/
void display_menu(row,col,menu,count)
char *menu[];
int row,col,count;
{   register int i;
    for (i=0; i<count; i++,row++)
    {   setcur(row,col);
        wstr(menu[i],1);
    }
    return;
}
/*---------------------------- is_in ------------------------------
    Returns position of char in string or zero if not there
*/
int is_in(s,c)
char *s, c;
{   register int i;
    for(i=0; *s; i++) if(*s++ == c) return(i+1);
    return(0);
}

/*--------------------------- menu_response ---------------------
    Gets user response to present menu
*/
int menu_response(row,col,menu,count,keys)
char *menu[];
char *keys;
int row,col,count;
{   int c;
    int arrow_choice = 0, key_choice;

    for (;;)
    {   /* highlight this selection */
        setcur(row+arrow_choice,col);
        wchar('\1'); wstr(menu[arrow_choice],0); wchar('\2');
        c = gtkey();
        setcur(row+arrow_choice,col);
        /* restore selection to normal */
        wchar('\2'); wstr(menu[arrow_choice],0);
        key_choice = is_in(keys,tolower(c));
        if (key_choice) return (key_choice-1);
        /* Look for special keys */
        switch (c)
        {   case '\n':
                return(arrow_choice);
            case ESC:
                return(-1); /* Cancel selection */
            case ' ':
            case DOWN:
                if (++arrow_choice >= count) arrow_choice = 0;
                break;
            case UP:
                if (--arrow_choice < 0) arrow_choice = count-1;
                break;
        }
    }
}
/*--------------------------- pop_up ---------------------------
    Presents a pop-up menu and returns user selection
    Returns -2 if menu can not be constructed
    Returns -1 if user hits ESC
    else, returns the menu item number (zero to count-1)
*/
int pop_up(row,col,menu,count,keys,border)
char *menu[];
char *keys;
int count,row,col,border;
{   register short i,len;
    short endrow, endcol, choice, posn;
    unsigned int p;
   
    wchar('\2');
    if (row > 23 || row < 0 || col > 79 || col < 0) return(-2);
    for (len = 0, i = 0; i<count; i++)
        if(strlen(menu[i]) > len) len = strlen(menu[i]);
    endcol = len + col + 1;
    endrow = row + count + 1;
    if (endrow+1 > 23 || endcol+1 > 79) return(-2);
    p = (unsigned int)malloc((endcol - col + 1) * (endrow - row + 1));
    posn=getcur();
    save_video(row,col,endrow,endcol,p);
    if (border) draw_box(row,col,endrow,endcol);
    display_menu(row+1,col+1,menu,count);
    choice = menu_response(row+1,col+1,menu,count,keys);
    restore_video(row,col,endrow,endcol,(char *)p);
    free(p);
    setcur(posn/256,posn%256);
    return (choice);
}

