/* saveform - Part of Form Fill-r program
*/

/* #define DEBUG */
#include "globals.h"
#include <stdlib.h>

extern void give_error(char *text);
extern void display_status();
extern void pick_file_prompt(char *message);
extern void fkeydefn(int i, int j, int k, char *message);
extern void draw_a_box(int y1, int x1, int y2, int x2, int dflag);
extern void strip_trailing(char *str);
extern void rem_ul(char *str);

char Unable_To_Open[]="Unable to open file";

/* Don't compile in the Demo version. */

#ifndef DEMO

/* ---------------------------------------------------------------- */
int saveform()

{
int	x;	/* Key pressed to exit GEDITS */
int	number;	/* True if field has a value, and thus we must output
		   the decimal point. */
char	c, save_name[81];
char	save_field[82];		/* Accumulate field for save file here */
char	*pw, *ps, *pm;		/* Scan across: work, save field, mask */
struct field *afield;
FILE *save_file;

    *save_name = '\0';  /* Delete residual junk */
    do
    {   pick_file_prompt("Save Current Form");
        save_file=NULL;
	fkeydefn(21,0,10,"Do not Save");
	draw_a_box(10,10,14,51,1);
        setcur(11,12);
	wstr("Enter up to 8 Characters for Save Name");
	display_status();
	stat_line=empty;
        get_mode=1;
        x=gedits(13,12,save_name,bgd,NULL);
	rem_ul(save_name);
	strip_trailing(save_name);

        if(x==F10 || x==EOF || x==ESC) return(x);
        if (strstr(save_name,".")!=NULL || strlen(save_name)>8)
        {   give_error("Invalid file name");
            continue;
        }
        strcat(save_name,FormSave);
        /* Try to open. Check for over write */
        if ((save_file = fopen(save_name,"rb+")) != NULL)
        {   fclose(save_file); /* Always close, if used, will be deleted */
            save_file = NULL;
            setcur(23,0);
            wstr("Write over existing file? (Y/N) ",1);

            while ((c=toupper(gtkey())) != 'Y' && c != 'N');
            if (c == 'Y')
            {   if (remove(save_name) == -1)
                {   give_error("Cannot delete file");
		    return (0);
		}
            }
            else
            {   give_error("Form NOT saved");
                return(0);
            }
        }
        if ((save_file = fopen(save_name,"wb+")) == NULL)
            give_error(Unable_To_Open);
	*strstr(save_name,".") = '\0';	/* Remove extension */
    } while (save_file == NULL);
    fputs(form_name,save_file); fputs("\r\n",save_file);
    for (afield = first_data_field; afield != NULL; afield = afield -> next)
    {   if (afield -> work != NULL && !(afield -> prot))
	/* Found a data field, save it.  Don't save things we've calculated. */
	  { ps = save_field;
	    pw = afield -> work;
	    pm = afield -> mask;
	    number = (afield -> value != 0);
	    while (*pw != '\0')
	      {	if (*pw != *pm || (number && (*pm == '.')))
				  /* Look for chars that differ from the mask. */
				  /* Also save decimal points in numeric fields. */
		  *ps++ = *pw++;  /* Save character & advance */
		else
		  ++pw;
		pm++;
	      }
	    *ps = '\0';		  /* Null-terminate new field */
	    fputs(save_field, save_file);
            fputs("\r\n",save_file);
          }
    }
    fclose(save_file);
    return(0);
}

#endif
